(*
 *                     The OCaml-gtk interface
 *
 * Copyright (c) 1997, 1998   David Monniaux & Pascal Cuoq
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 * [see the file COPYING.LIB]
 *)

(* $Id: old_test.ml,v 1.1 1998/11/29 15:03:42 monniaux Exp $ *)

open GtkObj;;
open GtkEasy;;
open Menu;;

let do_nothing () = ()

let menu = make_menu_bar
  [Submenu((Label "Langages"),
    [(Check_item((Label "C"), (ref false), do_nothing));
     (Submenu((Label "ML"),
       [(Check_item((Label "Caml"), (ref false), do_nothing));
        (Check_item((Label "SML"), (ref false), do_nothing))]))
    ]);
   Submenu((Label "Normaliens"),
    [(Radio_items
       ((ref "TMOY"),
        [((Label "TMOY"), "TMOY", do_nothing);
        ((Label "FKey"), "FKey", do_nothing)
       ]) );
     (Radio_items
       ((ref "Mathieu"),
        [((Label "Verzi"), "TMOY", do_nothing);
        ((Label "Mathieu"), "TMOY", do_nothing)
       ]) )
    ])
  ];;
  
let window = window_new Gtk.WINDOW_TOPLEVEL in
  let vbox = vbox_new false 0 in
begin
List.iter (function widget, z ->
  vbox #pack_start widget false false z;
  widget #show )
  [ (label_new "Dialog box" :> widget), 0;

    (let hbox = hbox_new true 0 in
    List.iter (function widget, z ->
      hbox #pack_start widget false false z;
      widget #show )
      [ (let vbox = vbox_new false 1 in
      List.iter
        (function title,tip ->
          let button = check_button_new_with_label title in
          button #set_tip tip "totoro";
          button #show;
          vbox #pack_start (button :> widget) true false 0;
          ) ["foo", "Let's dance.";
              "bar", "There's a lady who's sure of it.";
              "moo", "May the force be with you !";
              "cow", "Summertime and the living is easy..."];
      (vbox :> widget), 0); 

       	(vseparator_new () :> widget), 5;

        (let vbox = vbox_new false 1 and
            titles, tips = List.split
            ["ZOINX", "Let's dance.";
              "bird", "There's a lady who's sure of it.";
              "wolf", "May the force be with you !";
              "rabbit", "Summertime and the living is easy..."] in
        let buttons = radio_buttons_new_with_labels titles
        in radio_buttons_set_index buttons 1;
	List.iter2
          (fun button tip ->
            button #show;
            button #set_tip tip;
            vbox #pack_start (button :> widget) true false 0
              ) buttons tips;
        (vbox :> widget), 0) ];
    (hbox :> widget), 5);

    (hseparator_new () :> widget), 5;

    ((menu :> widget), 5);

    (let lst = list_new() in
      let zozo = (List.map list_item_new_with_label
        ["Abc";"DEF";"ghi";"01234"]) in
       List.iter (fun x-> x#show) zozo;
       lst #append_items zozo;
      (lst :> widget), 5);

    (hseparator_new () :> widget), 5;

    (let ratio = ref 0.5 and pbar = progress_bar_new () in
    pbar #show;
    pbar #update !ratio;
    Gtk.timeout_add 200 (fun _ ->
      ratio := !ratio +. 0.04;
      if !ratio > 1.0 then ratio := 0.0;
      pbar #update !ratio; true); 
    (pbar :> widget), 5);

    (hseparator_new () :> widget), 5;

    (let quitbox = hbox_new false 0 in
    ( let quit = button_new_with_label "Quit" in
    quit #connect_enter (fun ()-> Printf.fprintf stderr "enter quit\n";
      flush stderr);
    quit #connect_clicked Gtk.main_quit;
    quit #show;
    quitbox #pack_start (quit :> widget) true false 0
      );
    (quitbox :> widget), 0 )];

vbox #show;
window #add (vbox :> widget);
end;

window #border_width 10;
window #set_title "Test of O'Caml-gtk";
window #connect_delete_event (fun _ -> Gtk.main_quit (); false);
window #connect_move_resize (fun w h ->
     Printf.fprintf stderr "move_resize %d %d\n" w h;
     flush stderr;
     true );
window #show;;
